function [pObj, pBk] = computeDistributions(It, rect, k, b)

if(nargin < 4)
    b = 5;
end

numBins = 2^b;

x0 = rect(1);
y0 = rect(2);
xN = rect(3);
yN = rect(4);

numRows = yN-y0+1;
numCols = xN-x0+1;

bkPadX = round(0.75*numCols);
bkPadY = round(0.75*numRows);

rectBk = [x0-bkPadX,y0-bkPadY,xN+bkPadX,yN+bkPadY];
featuresBk = seedFeatures(It,rectBk,k);
featuresObj = featuresBk(bkPadY:bkPadY+numRows, bkPadX:bkPadX+numCols);
featuresBk(bkPadY:bkPadY+numRows, bkPadX:bkPadX+numCols) = -1;


pObj = zeros(numBins,1);
pBk = pObj;

featuresObj = featuresObj(:);
featuresBk = featuresBk(featuresBk > -1);

bins = linspace(0,255,numBins+1);
pObj = histc(featuresObj,bins)/size(featuresObj,1);
pObj(numBins) = pObj(numBins) + pObj(numBins+1);
pObj = pObj(1:numBins);
pBk  = histc(featuresBk, bins)/size(featuresBk, 1);
pBk(numBins) = pBk(numBins) + pBk(numBins+1);
pBk = pBk(1:numBins);

