function rects = discriminativeTracking(sequence, initRect)

% clear all;
% clc;
% 
% load('soccer.mat');
% 
% initRect = [232,95,258,141]; %Red Player
% % initRect = [123,88,147,132]; %White Player
% 
% %%%%%%%%%%%%%%%%%%%%%%%

b = 5;
N = 5;

[numPixY, numPixX, numChan, numFrame] = size(sequence);

rects = zeros(numFrame,4);
rects(1,:) = initRect;

x0 = initRect(1);
y0 = initRect(2);
xN = initRect(3);
yN = initRect(4);
numRows = yN-y0+1;
numCols = xN-x0+1;
bkPadX = round(0.75*numCols);
bkPadY = round(0.75*numRows);
numRowsBk = numRows + 2*bkPadY;
numColsBk = numCols + 2*bkPadX;

pObjs = zeros(2^b,49);
pBks = pObjs;
wImgs = zeros(numRowsBk, numColsBk, N);
for f = 1:numFrame-1
    rect = rects(f,:);
    x0 = rect(1);
    y0 = rect(2);
    xN = rect(3);
    yN = rect(4);
    
    figure(1);clf;
    imshow(sequence(:,:,:,f)); hold on;
    plot([x0,xN,xN,x0,x0],[y0,y0,yN,yN,y0],'r-','LineWidth',3);
    title(['Frame ',num2str(f)]);
 
    rectBk = [x0-bkPadX,y0-bkPadY,xN+bkPadX,yN+bkPadY];
    rowsBk = rectBk(2):rectBk(4);
    colsBk = rectBk(1):rectBk(3);
    
    It = sequence(:,:,:,f);
    It1 = sequence(:,:,:,f+1);

    for k = 1:49
        [pObjs(:,k),pBks(:,k)] = computeDistributions(It, rect, k, b);
    end
    if(f == 1)
        pObjsOrig = pObjs;
        pBksOrig = pBks;
    end

    sortedFeatureIndices = sortFeatures(pObjs+pObjsOrig, pBks+pBksOrig,N);

    for n = 1:N
        wImgs(:,:,n) = weightImage(It1, rectBk, pObjs, pBks, sortedFeatureIndices(n));
%         figure(2);
%         subplot(3,2,n);imagesc(wImgs(:,:,n));colormap('jet');
    end

    nextLocation = findNextLocation(wImgs);

    centerRow = floor(numRowsBk/2);
    centerCol = floor(numColsBk/2);
    dx = nextLocation(1) - centerCol;
    dy = nextLocation(2) - centerRow;

    rects(f+1,:) = rect + [dx,dy,dx,dy];
end
