function nextLocation = findNextLocation(weightImgs)

plotting = 1;

local =    [-1 -1
            -1  0
            -1  1
             0 -1
             0  1
             1 -1
             1  0
             1  1];

[numRowsExt, numColsExt, N] = size(weightImgs);
centerRow = floor(numRowsExt/2);
centerCol = floor(numColsExt/2);

numRows = round(numRowsExt/2.5);
if(mod(numRows,2) == 0)
    numRows = numRows + 1;
end
numCols = round(numColsExt/2.5);
if(mod(numCols,2) == 0)
    numCols = numCols + 1;
end

numInterpPts = max([numRows,numCols]);
beta = linspace(0,1,numInterpPts);

W = sum(weightImgs,3);
if(plotting)
    figure(3);clf;
    subplot(4,1,1);imagesc(W);colormap('jet');title('W');
end
W = sign(W).*(W.^2);
if(plotting)
    subplot(4,1,2);imagesc(W);colormap('jet');title('W^2');
end
gaussFilt = fspecial('gaussian',[numRowsExt,numColsExt],max([numRowsExt,numColsExt])/4);
W = W.*gaussFilt;
if(plotting)
    subplot(4,1,3);imagesc(W);colormap('jet');title('W^2*gauss');
end

if(1)
    gaussFiltX = fspecial('gaussian',[1,numCols],ceil(numCols/3));
    gaussFiltY = fspecial('gaussian',[numRows,1],ceil(numRows/3));
    avgW = conv2(conv2(W,gaussFiltX,'same'),gaussFiltY,'same');
else
    avgFilt = fspecial('average',[numRows,numCols]);
    avgW = conv2(W,avgFilt,'same');
end
if(plotting)
    subplot(4,1,4);imagesc(avgW);colormap('jet');title('Average W');
end

rowStart = (numRows-1)/2 + 1;
colStart = (numCols-1)/2 + 1;
maxLRow = -1;
maxLCol = -1;
maxL = -1;
for i = rowStart : numRowsExt - rowStart
    for j = colStart : numColsExt - colStart
        maxFound = 1;
        for k = 1:8
            if(avgW(i,j) <= avgW(i+local(k,1),j+local(k,2)))
                maxFound = 0;
                break;
            end
        end
        if(maxFound == 1)
            lineRows = round(beta*i + (1-beta)*centerRow);
            lineCols = round(beta*j + (1-beta)*centerCol);
            lineInds = lineCols*numRowsExt + lineRows;
            Lavg = sum(W(lineInds))/numInterpPts;
%             disp([num2str(j),', ',num2str(i),'; L_avg = ',num2str(Lavg)]);
            figure(3);
            hold on;
            plot([j,centerCol],[i,centerRow],'k-','LineWidth',6);
            if(maxLRow == -1)
                maxL = Lavg;
                maxLRow = i;
                maxLCol = j;
            else
                if(Lavg > maxL)
                    maxL = Lavg;
                    maxLRow = i;
                    maxLCol = j;
                end
            end
        end
    end
end

nextLocation = [maxLCol; maxLRow];
