clear all;
clc;

load('carSequence.mat');

rect = [328,213,419,265];
makePlot = 1;
rounding = 1;
usePrevDisp = 0;
smoothImgs = 0;
sigma = 8;

[numPixY, numPixX, numChan, numFrame] = size(sequence);

gaussian = fspecial('gaussian',[6*sigma+1,1],sigma);
bwSeq = zeros(numPixY, numPixX, numFrame);
for f = 1:numFrame
    bwSeq(:,:,f) = double(rgb2gray(sequence(:,:,:,f)))/255;
    if(smoothImgs == 1)
        bwSeq(:,:,f) = conv2(conv2(bwSeq(:,:,f),gaussian,'same'),gaussian','same');
    end
end

if(makePlot)
    warning('off','Images:imshow:magnificationMustBeFitForDockedFigure');
    figure(1);clf;
    col0 = rect(1);
    row0 = rect(2);
    colN = rect(3);
    rowN = rect(4);
    clf;
    imshow(sequence(:,:,:,1));hold on;
    plot([col0,colN,colN,col0,col0],[row0,row0,rowN,rowN,row0],'r-','LineWidth',4);
end

us = zeros(numFrame,1);
vs = us;
us(1) = 0;
vs(1) = 0;
for f = 1:numFrame - 1
    It = bwSeq(:,:,f);
    It1 = bwSeq(:,:,f+1);
    if(usePrevDisp == 1)
        uPrev = us(f);
        vPrev = vs(f);
    else
        uPrev = 0;
        vPrev = 0;
    end
    [us(f+1),vs(f+1)] = LucasKanade(It,rect,It1,uPrev,vPrev,rounding);
    rect([1,3]) = rect([1,3]) + us(f+1);
    rect([2,4]) = rect([2,4]) + vs(f+1);
    
    if(makePlot)
        col0 = rect(1);
        row0 = rect(2);
        colN = rect(3);
        rowN = rect(4);
        figure(1);clf;
        imshow(sequence(:,:,:,f+1)); hold on;
        plot([col0,colN,colN,col0,col0],[row0,row0,rowN,rowN,row0],'r-','LineWidth',4);
%         uv = [us(f+1),vs(f+1)]
%         rect = rect
    end
    %pause;
end
