clear all;
clc;

load('soccer.mat');

rect = [232,95,258,141];

b = 5;
N = 5;

x0 = rect(1);
y0 = rect(2);
xN = rect(3);
yN = rect(4);

numRows = yN-y0+1;
numCols = xN-x0+1;

bkPadX = round(0.75*numCols);
bkPadY = round(0.75*numRows);

rectBk = [x0-bkPadX,y0-bkPadY,xN+bkPadX,yN+bkPadY];
rowsBk = rectBk(2):rectBk(4);
colsBk = rectBk(1):rectBk(3);

[numPixY, numPixX, numChan, numFrame] = size(sequence);

It = sequence(:,:,:,1);
It1 = sequence(:,:,:,2);

warning('off','Images:imshow:magnificationMustBeFitForDockedFigure');

pObjs = zeros(2^b,49);
pBks = pObjs;
for k = 1:49
    [pObjs(:,k),pBks(:,k)] = computeDistributions(It, rect, k, b);
end

N = 5;
sortedFeatureIndices = sortFeatures(pObjs,pBks,N)

figure(1);clf;
subplot(2,3,1);imshow(It1(rowsBk,colsBk,:));title('Frame 2');
for n = 1:N
    wImg = weightImage(It1, rectBk, pObjs, pBks, sortedFeatureIndices(n));
    subplot(2,3,n+1);
    imagesc(wImg);colormap('jet');
end
